VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTaskBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
' Asdrubal R. Velasquez
' yv6esd@comports.com

'TaskBar
Private Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    UID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

' Estas variables se utilizan para la captura de
' eventos en el form ( hay que definirlas alli)
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205

Private Declare Function Shell_NotifyIcon _
      Lib "shell32" _
      Alias "Shell_NotifyIconA" ( _
      ByVal dwMessage As Long, _
      pnid As NOTIFYICONDATA) _
      As Boolean


Public Sub ColocarIcono(ByVal hWnd As Long, ByVal hIcon As Long, ByVal sToolTip As String)
'Inicializa los mensajes para la barra de tareas
Dim udtNOTIFYICONDATA As NOTIFYICONDATA

With udtNOTIFYICONDATA
   .cbSize = Len(udtNOTIFYICONDATA)
   
   .hWnd = hWnd
   '.UID = 1&
   .UID = vbNull
   .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
   .uCallbackMessage = WM_MOUSEMOVE
   .hIcon = hIcon
   
   ' ToolTip en la Barra de Tareas
   .szTip = sToolTip & vbNullChar
End With

'agregar a la Barra
Shell_NotifyIcon NIM_ADD, udtNOTIFYICONDATA

End Sub


Public Sub CambiarIcono(ByVal hWnd As Long, ByVal hIcon As Long, Optional ByVal sToolTip As String)
'Inicializa los mensajes para la barra de tareas
Dim udtNOTIFYICONDATA As NOTIFYICONDATA

With udtNOTIFYICONDATA
   .cbSize = Len(udtNOTIFYICONDATA)
   
   .hWnd = hWnd
   '.UID = 1&
   .UID = vbNull
   .hIcon = hIcon
   .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
   .uCallbackMessage = WM_MOUSEMOVE
   
   ' ToolTip en la Barra de Tareas
   If IsEmpty(sToolTip) Then
      .szTip = "" & vbNullChar
   Else
      .szTip = sToolTip & vbNullChar
   End If
End With

'agregar a la Barra
Shell_NotifyIcon NIM_MODIFY, udtNOTIFYICONDATA

End Sub


Public Sub QuitarIcono(ByVal hWnd As Long)
Dim udtNOTIFYICONDATA As NOTIFYICONDATA
With udtNOTIFYICONDATA
   .cbSize = Len(udtNOTIFYICONDATA)
   .hWnd = hWnd
   '.UID = 1&
   .UID = vbNull
End With

Shell_NotifyIcon NIM_DELETE, udtNOTIFYICONDATA

End Sub


